##  tid-sdk-embedded-c 

### 介绍

tid-sdk-embedded-c 面向使用TID安全服务的IOT终端设备开发者，TID-SDK对应用层提供TID安全认证过程需要的认证及加解密需要的API，对硬件层屏蔽MCU和SE芯片数据交互协议细节。开发者只需根据所选的通信总线（I2C/SPI/UART/7816），适配实现物理层总线的初始化、收、发、超时判断接口即可，适配层接口单独剥离在port目录。

### TID-SDK软件架构
![](https://i.imgur.com/rFmxmrm.jpg)

### 目录结构

| 名称            | 说明 |
| ----            | ---- |
| port            | HAL层移植目录，针对具体选择的MCU和SE的通信方式实现对应的驱动,针对具体的软件环境实现延时函数 |
| sample          | tid应用示例，示例使用tid的流程及API调用示例|
| src             | tid数据封装协议及各SE芯片商总线协议包的适配 |
|   ├─────   inf  | tid API 接口|
|   	├───── tid_common  | tid 驱动匹配及APDU协议数据封装|
|   	├───── vendor_driver  |SE芯片商各通信总线 tid 驱动适配|
| README.md       | SDK使用说明 |

### SE芯片商加入
1.SE芯片需支持TID-APDU指令集，参见《TID安全芯片接口规范》
2.若SE芯片定义的各总线协议中数据部分没有包含标准的APDU数据，需修改总线协议，协议修改方式参见《TID安全芯片接口规范》
3.若SE芯片定义的各总线协议中数据部分包含标准的APDU数据，请参照 g_DriverTable 实现厂商驱动。

##### 注意：TID-SDK非开源软件，未经允许，不可以扩散给第三方使用。

### SDK接口说明
 关于 SDK 的更多使用方式及接口了解, 参见 tid_api_inf.h
