#include <stdint.h>
#include <string.h>
#include "tid_driver_comm.h"


#ifndef __WY_DRIVER_I2C_H__
#define __WY_DRIVER_I2C_H__


#define I2C_NAD					0x00
#define I2C_CMD_IBLOCK			0x02
#define I2C_CMD_GET_ATR			0x30
#define I2C_CMD_NAK				0xBA
#define I2C_CMD_STANDBY		 	0xF0

#define I2C_MIN_LEN				3
#define I2C_MAX_LEN				1024


//MCU resend times
#define I2C_RETRY_TIMES			3
//MCU request SE times
#define I2C_REQUEST_TIMES		3


//config for user debug I2C
//#define DEBUG_I2C


/*******************************************************************/
typedef struct{
	uint8_t lenlo;
	uint8_t lenhi;
	uint8_t nad;
	union{
		uint8_t cmd;
		uint8_t sta;
	}flag;
} WY_I2C_HEAD,*pWY_I2C_HEAD;


typedef struct{
	uint8_t lenlo;
	uint8_t lenhi;
	uint8_t nad;
	uint8_t sta;
	uint8_t buf[512];
} WY_RxBuf,*pWY_RxBuf;

typedef struct{
	uint8_t lenlo;
	uint8_t lenhi;
	uint8_t nad;
	uint8_t cmd;
	uint8_t buf[512];
} WY_TxBuf,*pWY_TxBuf;


/*******************************************************************/
extern sTidFunc gwy_func_i2c ;

#endif

