#ifndef _GPIO_I2C_H_
#define _GPIO_I2C_H_

#include "stdint.h"
#include "bitband.h"


#define SCL    10		//PB10
#define SDA    11		//PB11


#define GPIO_LOW	0
#define GPIO_HIGH   1


#define ACK_LOW    GPIO_LOW
#define ACK_HIGH   GPIO_HIGH

#define OUTP   GPIOB_ODR_Addr
#define INP    GPIOB_IDR_Addr

#define ACK_TIME_OUT    2000

#define set_gpio_direction(gpio_n, direct)    (direct == OUTP)?(GPIOB->CRH = 0xFFFF33FF):(GPIOB->CRH = 0xFFFF83FF)
#define set_gpio_value(gpio_n, value)         {\
												 BIT_ADDR(GPIOB_ODR_Addr, gpio_n) = value;\
											  }\
											  
#define get_gpio_value(gpio_n)                BIT_ADDR(GPIOB_IDR_Addr, gpio_n) 

#define delay()    							  HAL_DelayUs(1)

#define GPIO_I2C_PWR_ON_DELAY_MS				  20
#define GPIO_I2C_PWR_OFF_DELAY_MS				  10

#define SE_DEV_ADDR							0xE2


#define I2C_WRITE_MASK       (0) 
#define I2C_READ_MASK        (1)

typedef struct{
	uint8_t se_i2c_addr;
	void (*tid_i2c_power_on)(void);
	void (*tid_i2c_power_off)(void);
	void (*tid_i2c_init)(void);
	void (*tid_i2c_start)(void);
	void (*tid_i2c_stop)(void);
	uint8_t (*tid_i2c_send_char)(uint8_t ch);
	uint8_t (*tid_i2c_recv_char)(void);
	uint8_t (*tid_i2c_send_addr)(uint8_t ch);
} sTid_I2C_Driver;

extern sTid_I2C_Driver gusr_gpio_i2c_drv;

#endif
