#include <stdio.h>
#include <stdint.h>
#include <stdarg.h>
#include <stdbool.h>

#define _IN_            /* 表明这是一个输入参数. */
#define _OU_            /* 表明这是一个输出参数. */
//#define USE_LIBC_FUNC

typedef struct _Timer_ {
    uint32_t end_time;
}Timer;

#ifdef USE_LIBC_FUNC
#define  HAL_Printf(args...) printf(##args)
#else
void HAL_Printf(_IN_ const char *fmt, ...);
int HAL_Snprintf(_IN_ char *str, const int len, const char *fmt, ...);
#endif
int HAL_Vsnprintf(_IN_ char *str, _IN_ const int len, _IN_ const char *format, va_list ap);
void HAL_DelayMs(_IN_ uint32_t ms);
void HAL_DelayUs(_IN_ uint32_t us);
uint32_t HAL_GetTimeMs(void);
bool HAL_Timer_expired(Timer *timer);
void HAL_Timer_countdown_ms(Timer *timer, unsigned int timeout_ms);
void HAL_Timer_countdown(Timer *timer, unsigned int timeout);
int HAL_Timer_remain(Timer *timer);
void HAL_Timer_init(Timer *timer);  

