
#ifndef __PORT_I2C_H__
#define __PORT_I2C_H__

#include "tid_export.h"



#define SE_ADDR					0xE2

#define I2C_PWR_ON_DELAY		20
#define I2C_PWR_OFF_DELAY		10

//check I2C reg timeout
#define CHECK_TIMES				3000

#define WAIT_TIME_MS			3000

typedef struct{
	uint8_t se_i2c_addr;
	void (*tid_i2c_power_on)(void);
	void (*tid_i2c_power_off)(void);
	void (*tid_i2c_init)(void);
	void (*tid_i2c_start)(void);
	void (*tid_i2c_stop)(void);
	eTidResult (*tid_i2c_send_char)(uint8_t ch);
	eTidResult (*tid_i2c_recv_char)(void);
	eTidResult (*tid_i2c_send_addr)(uint8_t ch);
	eTidResult (*tid_i2c_recv_buf)(uint8_t *rbuf,uint16_t rlen);
	eTidResult (*tid_i2c_send_buf)(uint8_t *sbuf,uint16_t slen);
	void (*tid_i2c_wake)(void);
    void (*tid_i2c_standby)(void);
} sTid_I2C_Driver;


extern sTid_I2C_Driver gusr_i2c_drv;


#endif


