
#ifndef __TID_DRIVER_COMM_H__
#define __TID_DRIVER_COMM_H__

#include <stdint.h>
#include <stdio.h>
#include "tid_export.h"

//config MCU Polling SE interval
#define POLL_INTERVAL			0

//config MCU Polling SE time(uint:ms)
//6s
#define POLL_TIMEOUT			6000

/*APDU DATA MAX LEN*/
#define APDU_DATA_MAX_LEN		(256)

/******************************************************************************/
typedef struct{
	uint8_t cla;
	uint8_t ins;
	uint8_t p1;
	uint8_t p2;
	uint8_t lc;
	uint8_t apdu[APDU_DATA_MAX_LEN];
	uint16_t data_len;
	uint8_t le;
} sApduPack;



typedef struct{
	eBusType bus_type;
	void (*tid_driver_register)(void *user_drv);
	void (*tid_device_init)(void);
	void (*tid_open_device)(void);
	void (*tid_close_device)(void);
	eTidResult (*tid_dev_power_on)(uint8_t *rbuf, uint16_t *rlen);
	eTidResult (*tid_apdu_transceive)(uint8_t *sbuf, uint16_t slen, uint8_t *rbuf, uint16_t *rlen,\
										uint16_t poll_inv, uint32_t poll_timeout);
	void (*tid_driver_unregister)(void);
} sTidFunc;

typedef struct _sDrvierInfo_{
	eVendor vendor;
	eBusType type;
	sTidFunc * pfun;	
}sDrvierInfo;


/**********************************************************************************/
sTidFunc *tid_se_register(eBusType type, eVendor vendor);
void tid_se_unregister(sTidFunc *pfun);


#endif


