#ifndef __TID_EXPORT_H__
#define __TID_EXPORT_H__
#include "tid_log.h"
#include "tid_config.h"
#include "hal_timer.h"

#define TID_PROTO_LEN               (1)
#define TID_SUITE_LEN               (1)
#define TID_ID_LEN                  (16)
#define TID_PUBEY_HEADER_LEN        (2)
#define TID_PUBKEY_LEN              (64)
#define TID_PUBKEY_TOTAL_LEN        (TID_PUBEY_HEADER_LEN + TID_PUBKEY_LEN)
#define TID_NONCE_LEN               (16)
#define TID_SESSKEY_LEN             (32)
#define TID_SIGN_LEN                (32)
#define TID_CLT_AUTHCODE_LEN        (TID_SUITE_LEN + TID_PROTO_LEN + TID_ID_LEN + TID_NONCE_LEN + TID_PUBKEY_TOTAL_LEN + TID_SIGN_LEN)
#define TID_SRV_AUTHCODE_LEN        (TID_SUITE_LEN + TID_PROTO_LEN + TID_NONCE_LEN + TID_PUBKEY_TOTAL_LEN + TID_SIGN_LEN)

typedef enum _eBusType_{
	eBUS_I2C  = 0,
	eBUS_SPI  = 1,
	eBUS_UART = 2,
	eBUS_7816 = 3,
	eBUS_I2C_GPIO,
	eBUS_LINUX_EMU,
}eBusType;

typedef enum _eVendor_{
	eVENDOR_FM          = 0x9190,		
	eVENDOR_HDE         = 0x9191,		
	eVENDOR_NXP         = 0x9192,		
	eVENDOR_WY          = 0x9193,		
	eVENDOR_COMMON      = 0x9199,
	
	eVENDOR_LINUX_EMU   = 0x9F00,
}eVendor;


/**
 * TID SDK ??*/
typedef enum _eTidResult_{
    TID_ERR_SUCCESS             = 0,      
    TID_ERR_FAILURE             = -100,   
    TID_ERR_INVAL               = -101,
    TID_ERR_INIT                = -102,

	TID_ERR_RECV_ACK            = -201,   
	TID_ERR_LENGTH              = -202, 
	TID_ERR_LRC                 = -203, 
	TID_ERR_DATA_NOT_READY       = -204, 
	TID_ERR_APDU                = -205,
	TID_ERR_PARA                = -206,
	TID_ERR_OTHER  	            = -299,
	
	TID_ERR_CRC  	            = -301, 
	TID_ERR_INS 	            = -302, 
	TID_ERR_NULL	            = -303,
	TID_ERR_NOT_SUPP            = -304,
} eTidResult;


void tid_apdu_test(void);
/*
#ifndef TID_FUNC_ENTRY
#ifdef TID_DEBUG
#define TID_FUNC_ENTRY 	IOT_FUNC_ENTRY
#else
#define TID_FUNC_ENTRY
#endif
#endif
*/
#endif
