#include "tid_config.h"
#if (TID_BUS_TYPE == eBUS_I2C_GPIO)

#include "gpio_i2c.h"
#include "tid_export.h"


static uint8_t g_SlaveAddress = 0xE2;

void _user_gpio_i2c_dev_power_on(void)
{
	//PEout(4) = 1;
	HAL_DelayMs(GPIO_I2C_PWR_ON_DELAY_MS);

}


void _user_gpio_i2c_dev_power_off(void)
{

	//PEout(4) = 0;
	HAL_DelayMs(GPIO_I2C_PWR_OFF_DELAY_MS);
}

void _user_gpio_i2c_init(void)
{
	g_SlaveAddress = SE_DEV_ADDR;

	GPIOB->CRH = 0xFFFF77FF;	//PB10 SCL  PB11  SDA output
}

void _user_gpio_i2c_start(void)
{ 
	TID_FUNC_ENTRY
	//ʼGPIO 
	set_gpio_direction(SDA, OUTP); //SDAΪ 
	set_gpio_value(SDA, 1); //SDAΪߵƽ 
	set_gpio_value(SCL, 1); //SCLΪߵƽ 
	delay(); //ʱ 
	//ʼ 
	set_gpio_value(SDA, 0); //SCLΪߵƽʱSDAɸ߱ 
	delay(); 
}

void _user_gpio_i2c_stop(void)
{ 
	set_gpio_value(SCL, GPIO_HIGH); 
	set_gpio_direction(SDA, OUTP); 
	set_gpio_value(SDA, GPIO_LOW); 
	delay(); 
	set_gpio_value(SDA, GPIO_HIGH); //SCLߵƽʱSDAɵͱ 
}


uint8_t _gpio_i2c_read_ack(void) 
{ 
    unsigned char ret  = 0; 
    int timeout = ACK_TIME_OUT;
    set_gpio_value(SCL,GPIO_LOW); // SCL 
	set_gpio_direction(SDA, INP); //SDAΪ 
    delay(); 
    set_gpio_value(SCL,GPIO_HIGH); // SCL 
    delay();
    do {
        ret = get_gpio_value(SDA); //ȡACKź
        timeout --;
    } while((ACK_HIGH == ret) && (timeout > 0));
    if(timeout) {
	    set_gpio_value(SCL, GPIO_LOW);
		set_gpio_direction(SDA, OUTP);
		set_gpio_value(SDA, GPIO_HIGH);
        return 0;
	}
    else {
	    set_gpio_value(SCL, GPIO_LOW);
		set_gpio_direction(SDA, OUTP);
		set_gpio_value(SDA, GPIO_HIGH);   
        return 12;
	} 
}


void _gpio_i2c_send_ack(void) 
{ 
    set_gpio_direction(SDA, OUTP); //SDAΪ 
    set_gpio_value(SCL,GPIO_LOW); // SCL 
    set_gpio_value(SDA, GPIO_LOW); //ACKź 
    delay(); 
    set_gpio_value(SCL,GPIO_HIGH); // SCL 
    delay();
	set_gpio_value(SCL, GPIO_LOW); 
}

void _gpio_i2c_send_noack(void)
{
    set_gpio_direction(SDA, OUTP);
	set_gpio_value(SCL, GPIO_LOW);
	set_gpio_value(SDA, GPIO_HIGH);
	delay();
	set_gpio_value(SCL, GPIO_HIGH);
	delay();
	set_gpio_value(SCL, GPIO_LOW);
}



uint8_t user_gpio_i2c_send_char(uint8_t b) 
{ 
	TID_FUNC_ENTRY
    int i;
    set_gpio_direction(SDA, OUTP); //SDAΪ 
    for (i=7; i>=0; i--) { 
        set_gpio_value(SCL, GPIO_LOW); // SCL 
        delay(); 
        set_gpio_value(SDA, (((b & (1<<i)) > 0)?GPIO_HIGH:(GPIO_LOW))); //Ӹλλ׼ݽз 
        set_gpio_value(SCL, GPIO_HIGH); // SCL 
        delay(); 
    }
    return _gpio_i2c_read_ack(); //Ŀ豸ACKź
}


uint8_t user_gpio_i2c_recv_char(void) 
{ 
	TID_FUNC_ENTRY
    int i; 
    unsigned char r = 0; 
	int n_ack = 1;
	
    set_gpio_direction(SDA, INP); //SDAΪ 
    for (i=7; i>=0; i--) { 
        set_gpio_value(SCL, GPIO_LOW); // SCL 
        delay(); 
        r = (r <<1) | get_gpio_value(SDA); //Ӹλλ׼ݽжȡ 
        set_gpio_value(SCL, GPIO_HIGH); // SCL 
        delay(); 
    }
    if (n_ack == 0) 
        _gpio_i2c_send_ack(); //Ŀ豸ACKź
    else
        _gpio_i2c_send_noack(); 
	
    return  r; 
}


uint8_t user_gpio_i2c_send_addr(uint8_t ch)
{ 
	TID_FUNC_ENTRY
		
	int i;
	set_gpio_direction(SDA, OUTP); //SDAΪ 
	for (i=7; i>=0; i--) { 
		set_gpio_value(SCL, GPIO_LOW); // SCL 
		delay(); 
		set_gpio_value(SDA, (((ch & (1<<i)) > 0)?GPIO_HIGH:(GPIO_LOW))); //Ӹλλ׼ݽз 
		set_gpio_value(SCL, GPIO_HIGH); // SCL 
		delay(); 
	}
	return _gpio_i2c_read_ack(); //Ŀ豸ACKź
}


//global variable of I2C interface driver
sTid_I2C_Driver gusr_gpio_i2c_drv = 
{
	SE_DEV_ADDR,
	_user_gpio_i2c_dev_power_on,
	_user_gpio_i2c_dev_power_off,
	_user_gpio_i2c_init,
	_user_gpio_i2c_start,
	_user_gpio_i2c_stop,
	user_gpio_i2c_send_char,
	user_gpio_i2c_recv_char,
	user_gpio_i2c_send_addr
};

#endif
