#include "tid_export.h"

#if (TID_BUS_TYPE == TID_BUS_LINUX_EMU)
#include <stdio.h>

/********************************************************************
* Function: I2C SE power on
* Input Parameter:None
* Output Parameter:None
* Return: None
*********************************************************************/
void user_linux_dev_power_on(void)
{
    printf("%s_%d\n", __func__, __LINE__);
}

/********************************************************************
* Function: I2C SE power off
* Input Parameter:None
* Output Parameter:None
* Return: None
*********************************************************************/
void user_linux_dev_power_off(void)
{
   printf("%s_%d\n", __func__, __LINE__);    
}

/********************************************************************
* Function: I2C SE interface and IO init
* Input Parameter:None
* Output Parameter:None
* Return: None
*********************************************************************/
void user_linux_init(void)
{
    printf("%s_%d\n", __func__, __LINE__);
}

/********************************************************************
* Function: generate a I2C start signal
* Input Parameter:None
* Output Parameter:None
* Return: None
*********************************************************************/
void user_linux_start(void)
{
    printf("%s_%d\n", __func__, __LINE__);

}

/********************************************************************
* Function: generate a I2C stop signal
* Input Parameter:None
* Output Parameter:None
* Return: None
*********************************************************************/
void user_linux_stop(void)
{
    printf("%s_%d\n", __func__, __LINE__);
}

/********************************************************************
* Function: Master send a I2C Byte to slaver,and receive slaver ACK
* Input Parameter:
* ch: the send byte
* Output Parameter:None
* Return: result
* 0-success
* 12-wait ack timeout
*********************************************************************/
eTidResult user_linux_send_char(uint8_t ch)
{
    printf("Send %02x to SE\n", ch);

    return TID_ERR_SUCCESS;
}

/********************************************************************
* Function: Master receive a I2C Byte from slaver
* Input Parameter:None
* Output Parameter:None
* Return: master received byte from slaver
*********************************************************************/
uint8_t user_linux_recv_char(void)
{	
    printf("Receive a char from linux emulator\n");

    return 0;
}


/********************************************************************
* Function: I2C Master Receive DATA(start->send addr+R->receivedata->stop)
* Input Parameter: *rbuf: receive data buf
* Output Parameter: rlen: receive len
* Return: None
*********************************************************************/

eTidResult user_linux_recv_buf(uint8_t *rbuf,uint16_t rlen)
{
    printf("Receive buffer from linux emulator\n");

    return TID_ERR_SUCCESS;
}
/********************************************************************
* Function: I2C Master Send DATA(start->send addr+W->send data->stop)
* Input Parameter: *sbuf: send data buf
* Output Parameter: slen: send len
* Return: None
*********************************************************************/
eTidResult user_linux_send_buf(uint8_t *sbuf,uint16_t slen)
{
    return TID_ERR_NOT_SUPP;
}

void user_linux_dev_wake(void)
{

}

void user_linux_dev_standby(void)
{

}


//global variable of I2C interface driver
sTid_LINUX_Driver gusr_linux_drv = 
{
	SE_ADDR,
	user_linux_dev_power_on,
	user_linux_dev_power_off,
	user_linux_init,
	user_linux_start,
	user_linux_stop,
	user_linux_send_char,
	user_linux_recv_char,
	user_linux_recv_buf,
	user_linux_send_buf,
	user_linux_dev_wake,
	user_linux_dev_standby
};


#endif

