#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "hal_timer.h"

extern void delayms(uint32_t cnt);
extern void delayus(uint32_t cnt);


#ifndef USE_LIBC_FUNC
void HAL_Printf(_IN_ const char *fmt, ...)
{
    va_list args;
    va_start(args, fmt);
    vprintf(fmt, args);
    va_end(args);

//   fflush(stdout);
}

int HAL_Snprintf(_IN_ char *str, const int len, const char *fmt, ...)
{
    va_list args;
    int rc;

    va_start(args, fmt);
    rc = vsnprintf(str, len, fmt, args);
    va_end(args);

    return rc;
}
#endif

int HAL_Vsnprintf(_IN_ char *str, _IN_ const int len, _IN_ const char *format, va_list ap)
{
    return vsnprintf(str, len, format, ap);
}


void HAL_DelayMs(_IN_ uint32_t ms)
{
    delayms(ms);
}

void HAL_DelayUs(_IN_ uint32_t us)
{
    delayus(us);
}

extern uint32_t delayms_cnt;

uint32_t HAL_GetTimeMs(void)
{	
    return delayms_cnt;
}

bool HAL_Timer_expired(Timer *timer) 
{
    uint32_t now_ts;
	
	now_ts	= HAL_GetTimeMs();


    return (now_ts > timer->end_time)?true:false;
}

void HAL_Timer_countdown_ms(Timer *timer, unsigned int timeout_ms) 
{
	timer->end_time = HAL_GetTimeMs();
    timer->end_time += timeout_ms;	
}

void HAL_Timer_countdown(Timer *timer, unsigned int timeout) 
{
    timer->end_time = HAL_GetTimeMs();
	timer->end_time += timeout*1000;
}

int HAL_Timer_remain(Timer *timer) 
{
	 return (int)(timer->end_time - HAL_GetTimeMs()); 	
}

void HAL_Timer_init(Timer *timer) 
{
      timer->end_time = 0;
}
  

